require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to test the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator. If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails. There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.

RSpec.describe '/tools/decision_mats', type: :request do
  # Tools::DecisionMat. As you add validations to Tools::DecisionMat, be sure to
  # adjust the attributes here as well.
  let(:valid_attributes) { {rca_id: rca.id, tool_reference: 1, name: 'Matrix 1', entry_class: 'Tools::Task'} }
  let(:invalid_attributes) { {rca_id: rca.id, tool_reference: 1, name: 'Matrix 1', entry_class: 'Toto'} }

  let(:rca) { FactoryBot.create(:rca, methodology: methodology) }
  let(:methodology) { FactoryBot.create(:methodology, :with_step_1) }
  let(:user) { FactoryBot.create(:user) }
  let(:tools_task) { FactoryBot.create(:task, rca: rca) }

  context 'From logged user' do
    before :each do
      user.set_session(:active_step_tool, methodology.steps.first.step_tools.first.id)
      user.save!

      sign_in user
    end

    describe 'GET /index' do
      context 'without rca defined' do
        it 'renders a redirection response' do
          get tools_decision_mats_url

          expect(response).to have_http_status(:redirect)
          expect(response).to redirect_to(rcas_path)
        end
      end

      context 'with rca and step_tool defined' do
        it 'renders a successful response' do
          Tools::DecisionMat.create! valid_attributes

          get('/tools/decision_mats', params: {rca: rca.id})
          expect(response).to be_successful
        end
      end
    end

    describe 'GET /new' do
      it 'renders a successful response' do
        get new_tools_decision_mat_url(tools_decision_mat: valid_attributes), xhr: true
        expect(response).to be_successful
      end
    end

    describe 'GET /edit' do
      it 'render a successful response' do
        tools_decision_mat = Tools::DecisionMat.create! valid_attributes
        get edit_tools_decision_mat_url(tools_decision_mat), xhr: true
        expect(response).to be_successful
      end
    end

    describe 'POST /create' do
      context 'with valid parameters' do
        it 'creates a new Tools::DecisionMat' do
          expect {
            post tools_decision_mats_url, params: { tools_decision_mat: valid_attributes }, xhr: true
          }.to change(Tools::DecisionMat, :count).by(1)
        end

        it 'redirects to the created tools_decision_mat' do
          post tools_decision_mats_url, params: { tools_decision_mat: valid_attributes }, xhr: true

          expect(response).to be_successful
          # expect(response).to redirect_to(meth_step_tool_show_path(id: user.get_session(:active_step_tool), rca: rca))
        end
      end

      context 'with invalid parameters' do
        it 'does not create a new Tools::DecisionMat' do
          expect {
            post tools_decision_mats_url, params: { tools_decision_mat: invalid_attributes }, xhr: true
          }.to change(Tools::DecisionMat, :count).by(0)
        end

        it 'renders a successful response (i.e. to display the new template)' do
          post tools_decision_mats_url, params: { tools_decision_mat: invalid_attributes }, xhr: true
          expect(response).to be_successful
        end
      end
    end

    describe 'PATCH /update' do
      context 'with valid parameters' do
        let(:new_attributes) { {name: 'Matrix 2'} }

        it 'updates the requested tools_decision_mat' do
          tools_decision_mat = Tools::DecisionMat.create! valid_attributes
          patch tools_decision_mat_url(tools_decision_mat), params: { tools_decision_mat: new_attributes }, xhr: true
          tools_decision_mat.reload

          expect(tools_decision_mat.name).to eq 'Matrix 2'
        end

        it 'redirects to the tools_decision_mat' do
          tools_decision_mat = Tools::DecisionMat.create! valid_attributes
          patch tools_decision_mat_url(tools_decision_mat), params: { tools_decision_mat: new_attributes }
          tools_decision_mat.reload
          expect(response).to redirect_to(meth_step_tool_show_path(id: user.get_session(:active_step_tool), rca: rca))
        end
      end

      context 'with invalid parameters' do
        it 'renders a successful response (i.e. to display the edit template)' do
          tools_decision_mat = Tools::DecisionMat.create! valid_attributes
          patch tools_decision_mat_url(tools_decision_mat), params: { tools_decision_mat: invalid_attributes }, xhr: true
          expect(response).to be_successful
        end
      end
    end

    describe 'DELETE /destroy' do
      it 'destroys the requested tools_decision_mat' do
        tools_decision_mat = Tools::DecisionMat.create! valid_attributes
        expect {
          delete tools_decision_mat_url(tools_decision_mat)
        }.to change(Tools::DecisionMat, :count).by(-1)
      end

      it 'redirects to the tools_decision_mats list' do
        tools_decision_mat = Tools::DecisionMat.create! valid_attributes
        delete tools_decision_mat_url(tools_decision_mat)
        expect(response).to redirect_to(meth_step_tool_show_path(id: user.get_session(:active_step_tool), rca: rca))
      end
    end
  end
end
